//#include<iostream>
#include<cstdio>
#include<cctype>
#include<cmath>
#include<cstdlib>
#include<algorithm>
#include<vector>
#include<string>
#include<list>
#include<deque>
#include<map>
#include<set>
#include<queue>
#include<stack>
#include<utility>
#include<sstream>
#include<cstring>
using namespace std;

#define FOR(I,A,B) for(int I=(A);I<=(B);I++)
#define FORD(I,A,B) for(int I=(A);I>=(B);I--)
#define REP(I,N) for(int I=0;I<(N);I++)
#define ALL(X) (X).begin(),(X).end()
#define PB push_back
#define MP make_pair
#define X first
#define Y second
#define INFTY 100000000
#define VAR(V,init) __typeof(init) V=(init)
#define FORE(I,C) for(VAR(I,(C).begin());I!=(C).end();I++)

typedef vector<int> VI;
typedef pair<int,int> PII;
typedef long long ll;
typedef vector<string> VS;

ll nwd(ll a,ll b) { return !b?a:nwd(b,a%b); }
template <class T> inline T sqr(const T&a) { return a*a; }

#define MAXN 10000

short* dp[MAXN+1];

int main()
{
    char s1[MAXN+2], s2[MAXN+2];
    int n1, n2;
    scanf("%d%d", &n1, &n2);
    scanf("%s%s", s1+1, s2+1);
    REP(i, n1+1)
    {
        dp[i] = new short[n2+1];
        REP(j, n2+1)
            dp[i][j] = 0;
    }
    FOR(i, 1, n1) FOR(j, 1, n2)
        if(s1[i] == s2[j])
            dp[i][j] = dp[i-1][j-1]+1;
        else
            dp[i][j] = max(dp[i-1][j], dp[i][j-1]);

    int k = dp[n1][n2];
    char wyn[MAXN+2];
    wyn[k] = '\0';
    int px, py, pos = k-1;
    px = n1;
    py = n2;
    while(px && py)
    {
        if(s1[px] == s2[py])
        {
            wyn[pos--] = s1[px];
            px --;
            py --;
        } else if(dp[px][py] == dp[px-1][py])
            px --;
        else
            py --;
    }

    printf("%d\n", k);
    printf("%s\n", wyn);
    return 0;
}
